#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>
#include <Adafruit_NeoPixel.h>
#include <Adafruit_CircuitPlayground.h>
#include <stdlib.h>

float X,Y,Z;
#define BRIGHTNESS 25
  
Adafruit_NeoPixel strip = Adafruit_NeoPixel(64, 0, NEO_GRBW + NEO_KHZ800);
    
void setup() {
  Serial.begin(9600);
  CircuitPlayground.begin();
  strip.setBrightness(BRIGHTNESS);
  strip.begin();
  strip.show();
}

void loop() {
  // put your main code here, to run repeatedly:
 growingSquare();
 delay(5000);

 growingTriangle();
 delay(5000);

 for (int i = 0; i < 5; i++) {
  rotate();
 }

 delay(5000);
 
  for (int i = 0; i < 5; i++) {
    expandingSquare();
  }

  delay(5000);
}

void lightRow(int row) {
  if (row <= 8) {
    for (int i = 0; i<=7; i++) {
      strip.setPixelColor(i + 8*(row-1),175,0,0,50);
    }
  }
  strip.show();
}


void lightCol(int col) {
  if (col <= 8) {
    for (int i = 0; i<=7; i++) {
      strip.setPixelColor(i*8+(col-1),175,0,0,50);
    }
  }
  strip.show();
}

void cross() {
  lightRow(4);
  lightRow(5);
  lightCol(4);
  lightCol(5);
}

void xMarks() {
  for (int i = 0; i<=7; i++) {
    strip.setPixelColor(i*8+i,175,0,0,50);
  }
  for (int i = 8; i>=1; i--) {
    strip.setPixelColor(i*8-i,175,0,0,50);
  }
  strip.show();
}

void topLeft() {
  for (int i = 0; i<=7; i++) {
    strip.setPixelColor(i*8+i,175,0,0,50);
  }
  strip.show();
}


void bottomRight() {
  for (int i = 8; i>=1; i--) {
    strip.setPixelColor(i*8-i,175,0,0,50);
  }
  strip.show();
}

void colorWipe() {
  for(int i=0; i<64; i++) {
    strip.setPixelColor(i, 0,0,0);
  }
  strip.show();
}

void rotate() {
  lightRow(4);
  lightRow(5);
  delay(1000);
  colorWipe();
  
  topLeft();
  delay(1000);
  colorWipe();
  
  lightCol(4);
  lightCol(5);
  delay(1000);
  colorWipe();
  
  bottomRight();
  delay(1000);
  colorWipe();
}

void square(int size) {
  if (size <= 6) {
    for (int i = 1; i <= size; i++) {
      for (int j = 1; j <= size; j++) {
        strip.setPixelColor((i*8+j),175,0,0,50);
      }
    }
  }
  strip.show();
}




void square2() {
  for (int i = 27; i < 40; i+=8) {
    strip.setPixelColor(i,175,0,0,50);
    strip.setPixelColor(i+1,175,0,0,50);
  }
  strip.show();
}

void square4() {
    for (int i = 18; i < 46; i+=8) {
      for (int j = 0; j<=3; j++) {
      strip.setPixelColor(i+j,175,0,0,50);
    }
  }
  strip.show();
}

void square6() {
  square(6);
}

void square8() {
  for (int i = 0; i<64;i++) {
    strip.setPixelColor(i,175,0,0,50);
  } 
  strip.show();
}

void triangle(int size) {
  if (size <= 6) {
    for (int i = 1; i <= size; i ++){
      for (int j=i; j <=size; j++) {
        strip.setPixelColor(i+(j*8),175,0,0,50);
      }
    }
  }
  strip.show();
}

void growingTriangle() {
  triangle(1);
  delay(1000);
  colorWipe();
  triangle(2);
  delay(1000);
  colorWipe();
  triangle(3);
  delay(1000);
  colorWipe();
  triangle(4);
  delay(1000);
  colorWipe();
  triangle(5);
  delay(1000);
  colorWipe();
  triangle(6);
  delay(1000);
  colorWipe();
}


void growingSquare() {
  square(1);
  delay(1000);
  colorWipe();
  square(2);
  delay(1000);
  colorWipe();
  square(3);
  delay(1000);
  colorWipe();
  square(4);
  delay(1000);
  colorWipe();
  square(5);
  delay(1000);
  colorWipe();
  square(6);
  delay(1000);
  colorWipe();
}
void expandingSquare() {
  square2();
  delay(1000);
  colorWipe();
  
  square4();
  delay(500);
  colorWipe();
  
  square6();
  delay(250);
  colorWipe();
  
  square8();
  delay(1000);
  colorWipe();
  
  square6();
  delay(250);
  colorWipe();
  
  square4();
  delay(500);
  colorWipe();
  
  square2();
  delay(1000);
  colorWipe();
  
}

